
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; FILE: entity.s
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;-----------------------------LICENSE NOTICE------------------------------------
;;    Crocker. A game for AmstradCPC.
;;    Copyright (C) 2018  Merienda
;;          Sara Vilaplana Rua
;;          Enrique Cortés Tarraga
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "entity.h.s"
.include "main.h.s"

.globl _cocodrilo_sprites
.globl _bocadillo_sprites
.globl _camion_sprites
.globl _coche_sprites
.globl _fuego_sprites

entity_vector:
k_max_num_ent = 10
k_entity_size = 9

DefineNEntities entity_vector, k_max_num_ent

;;DefineEntity name, x, y, vx, vy, w, h, color

DefineEntity hero_data, 0x40, 0xA8, 0x00, 0x00, 0x02, 0x08, 0x0F, ent_moveKeyboard

DefineEntity bocadillo, 0x25, 0x02, 0x00, 0x00, 0x02, 0x08, 0x0F, ent_no_move

DefineEntity fuego, #28, 0x02, 0x00, 0x00, 0x02, 0x08, 0x0F, ent_no_move
DefineEntity fuego1, #45, 0x02, 0x00, 0x00, 0x02, 0x08, 0x0F, ent_no_move

DefineEntity camion2, #70, 0x50, 0x00, 0x00, 0x08, 0x08, 0x0F, ent_move_lentoDI
DefineEntity coche1, #70, 0x80, 0x00, 0x00, 0x08, 0x08, 0x0F, ent_move_lentoDI
DefineEntity coche2, #70, 0x20, 0x00, 0x00, 0x08, 0x08, 0x0F, ent_move_lentoDI
DefineEntity coche3, #70, 0x20, 0x00, 0x00, 0x08, 0x08, 0x0F, ent_move_lentoDI




m_num_ent:     .db 00
m_next_entity: .dw entity_vector

m_pos_x: .db 0xA8
m_pos_y: .db 0x00




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DIBUJAR UNA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_draw:

      ld    de, #0xC000       ;;Comienzo memoria de video
      ld     c, e_x(ix)         ;; C = Entity Y
      ld     b, e_y(ix)         ;; B = Entity X
      call cpct_getScreenPtr_asm		;; Get pointer to screen


      ex    de, hl   ;; DE = Puntero a memoria
      ld  hl, #_cocodrilo_sprites
      ld  b, #16 ;; alto
      ld  c, #8   ;; Ancho

      call cpct_drawSprite_asm
      ;;call cpct_drawSolidBox_asm

ret



ent_draw_camion:

      ld    de, #0xC000       ;;Comienzo memoria de video
      ld     c, e_x(ix)         ;; C = Entity Y
      ld     b, e_y(ix)         ;; B = Entity X
      call cpct_getScreenPtr_asm		;; Get pointer to screen

      ex    de, hl   ;; DE = Puntero a memoria
      ld  hl, #_camion_sprites
      ld  b, #32 ;; alto
      ld  c, #16  ;; Ancho

      call cpct_drawSprite_asm

ret


ent_draw_coches:

      ld    de, #0xC000       ;;Comienzo memoria de video
      ld     c, e_x(ix)         ;; C = Entity Y
      ld     b, e_y(ix)         ;; B = Entity X
      call cpct_getScreenPtr_asm		;; Get pointer to screen

      ex    de, hl   ;; DE = Puntero a memoria
      ld  hl, #_coche_sprites
      ld  b, #32 ;; alto
      ld  c, #16  ;; Ancho

      call cpct_drawSprite_asm
      ;;call cpct_drawSolidBox_asm

ret


ent_draw_bocata:

      ld    de, #0xC000       ;;Comienzo memoria de video
      ld     c, e_x(ix)         ;; C = Entity Y
      ld     b, e_y(ix)         ;; B = Entity X
      call cpct_getScreenPtr_asm		;; Get pointer to screen


      ex    de, hl   ;; DE = Puntero a memoria
      ld  hl, #_bocadillo_sprites
      ld  b, #8 ;; alto
      ld  c, #8 ;; Ancho

      call cpct_drawSprite_asm
      ;;call cpct_drawSolidBox_asm

ret

ent_draw_fuego:

      ld    de, #0xC000       ;;Comienzo memoria de video
      ld     c, e_x(ix)         ;; C = Entity Y
      ld     b, e_y(ix)         ;; B = Entity X
      call cpct_getScreenPtr_asm		;; Get pointer to screen


      ex    de, hl   ;; DE = Puntero a memoria
      ld  hl, #_fuego_sprites
      ld  b, #16 ;; alto
      ld  c, #8 ;; Ancho

      call cpct_drawSprite_asm
      ;;call cpct_drawSolidBox_asm

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; BORRA UNA ENTIDAD
;; REGISTROS DESTRUIDOS: AF, BC, DE, HL
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_clear:

ret

ent_clear_coches:


ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ACTUALIZAR UNA ENTIDAD
;; REGISTROS DESTRUIDOS:
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_update:
   ld     h, e_up_h(ix)
   ld     l, e_up_l(ix)
   jp    (hl)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COMPROBAR COLISION DE UNA ENTIDAD
;; ENTRADA: IY -> Puntero a entidad
;;          IX -> Puntero a jugador
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ent_checkCollision::

      ld a, e_y(iy) 				
      ld b, a 						
      ld a, e_y(ix)					
      ld c, a 						
      ld a, e_h(ix)					
      add c  							
      sub b 							
      jr z, no_collision 				
      jp m, no_collision 	



      ld a, e_y(ix) 				
      ld c, a 					
      ld a, e_h(iy) 				
      ld b, a 						
      ld a, e_y(iy) 				
      add b 							
      sub c 							
      jr z, no_collision 				
      jp m, no_collision 	


	
      ld a, e_x(iy) 				
      ld b, a 						
      ld a, e_x(ix)					
      ld c, a 						
      ld a, e_w(ix)					
      add c  						
      sub b 						
      jr z, no_collision 				
      jp m, no_collision 				



      ld a, e_x(ix) 				
      ld c, a 						
      ld a, e_w(iy) 				
      ld b, a 						
      ld a, e_x(iy) 				
      add b 							
      sub c 							
      jr z, no_collision 				
      jp m, no_collision 				


      ld    e_x(ix), #25 
      ld    e_y(ix), #180						
      
      ret

	no_collision:						
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COMPROBAR COLISION DE UNA ENTIDAD
;; ENTRADA: IY -> Puntero a entidad
;;          IX -> Puntero a jugador
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ent_checkCollisionBocadillo::

      ld a, e_y(iy) 				
      ld b, a 						
      ld a, e_y(ix)					
      ld c, a 						
      ld a, e_h(ix)					
      add c  							
      sub b 							
      jr z, no_col_boca				
      jp m, no_col_boca 	



      ld a, e_y(ix) 				
      ld c, a 					
      ld a, e_h(iy) 				
      ld b, a 						
      ld a, e_y(iy) 				
      add b 							
      sub c 							
      jr z, no_col_boca				
      jp m, no_col_boca 																														 		

      ld    e_x(ix), #25 
      ld    e_y(ix), #180

      ld    a, #0		
      
      ret

	no_col_boca:						
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MOVER UNA ENTIDAD CON TECLADO
;; REGISTROS DESTRUIDOS:
;; ENTRADA: IX -> Puntero a entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ent_moveKeyboard:

   ld    b, e_x(ix) ;;Nos guardamos el valor anterior de la X
   ld    c, e_y(iy) ;;Nos guardamos el valor anterior de la Y

   call  cpct_scanKeyboard_asm

;;El personaje se mueve hacia la izquierda
   ld    hl, #Key_A
   call  cpct_isKeyPressed_asm
   jr    z, a_no_pulsada
      ld    a, e_x(ix)
      ld b, #0
      cp b
      jr z, a_no_pulsada
      sbc   a, #1
      ld    e_x(ix), a
      
a_no_pulsada:

;;El personaje se mueve a la derecha
   ld    hl, #Key_D
   call  cpct_isKeyPressed_asm
   jr    z, d_no_pulsada
      ld    a, e_x(ix)
      ld b, #72
      cp b
      jr z, d_no_pulsada
      add   a, #1
      ld    e_x(ix), a
   

d_no_pulsada:

;;El personaje se mueve hacia arriba
   ld    hl, #Key_W
   call  cpct_isKeyPressed_asm
   jr    z, w_no_pulsada
      ld    a, e_y(ix)
      ld    b, #2
      cp    b
      jr z, w_no_pulsada
      sbc   a, #2
      ld    e_y(ix), a
w_no_pulsada:

;;El personaje se mueve hacia abajo
   ld    hl, #Key_S
   call  cpct_isKeyPressed_asm
   jr    z, s_no_pulsada
      ld    a, e_y(ix) 
      ld    b, #180
      cp    b
      jr    z, s_no_pulsada
      add   a, #2
      ld    e_y(ix), a
s_no_pulsada:


ret

ent_no_move:

ret


depura:

ret

ent_move_lentoDI:
	ld    a, e_x(ix)
      sbc   a, #1
      jr    nz, no_vuelve_inicioDL
            ld    a, #80
      no_vuelve_inicioDL:
      ld    e_x(ix), a
ret


